/* compconn.c */

/* Direttive */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "grafo-fs.h"


#define ROW_LENGTH 256


/* Prototipi delle procedure secondarie e definizione di tipi */

typedef int *vint;

/* Legge dalla linea di comando il file che contiene il grafo */
void InterpretaLineaComando (int argc, char *argv[], char *filedati);

/* Carica dal file filedati il grafo G, assumendo che sia orientato o no secondo il valore di Orientato */
void CaricaGrafo (char *filedati, grafo *pG, boolean Orientato);


/* Programma principale */
int main (int argc, char *argv[])
{
  char filedati[ROW_LENGTH];
  grafo G;


  /* Legge da linea di comando il file che contiene il grafo */
  InterpretaLineaComando(argc,argv,filedati);

  /* Carica il grafo */
  CaricaGrafo(filedati,&G,FALSE);

  /* Stampa a video il grafo */
  printf("G = ");
  stampagrafo(&G);
  printf("\n");

  /* Crea una soluzione C vuota */

  /* Determina le nc componenti connesse del grafo G nel vettore C */

  /* Stampa le componenti connesse */

  /* Dealloca le strutture dati dinamiche */
  distruggegrafo(&G);

  return EXIT_SUCCESS;
}


/* Definizione delle procedure secondarie */

/* Legge dalla linea di comando il file che contiene il grafo */
void InterpretaLineaComando (int argc, char *argv[], char *filedati)
{
  if (argc != 2)
  {
    fprintf(stderr,"Errore nella linea di comando!\n");
    exit(EXIT_FAILURE);
  }

  strcpy(filedati,argv[1]);
}


/* Carica dal file filedati il grafo G, assumendo che sia orientato o no secondo il valore di Orientato */
void CaricaGrafo (char *filedati, grafo *pG, boolean Orientato)
{
  FILE *fp;
  int o, d, n;

  /* Apre il file */
  fp = fopen(filedati,"r");
  if (fp == NULL)
  {
    fprintf(stderr,"Errore nell'apertura del file %s!\n",filedati);
    exit(EXIT_FAILURE);
  }

  /* Conta i nodi del grafo */
  n = 0;
  while (fscanf(fp," (%d,%d)",&o,&d) == 2)
  {
    if (o > n) n = o;
    if (d > n) n = d;
  }

  /* Crea il grafo, assumendo che gli indici dei nodi vadano da 1 a n */
  creagrafo(n,pG);

  /* Aggiunge gli archi del grafo */
  rewind(fp);
  while (fscanf(fp," (%d,%d)",&o,&d) == 2)
  {
    insarco(o,d,pG);
    if (!Orientato) insarco(d,o,pG);
  }

  /* Chiude il file */
  fclose(fp);
}
